###################################################
### chunk number 1: 
###################################################
#line 158 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
library(gmm)


###################################################
### chunk number 2: 
###################################################
#line 178 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
g1 <- function(tet,x)
        {
        m1 <- (tet[1]-x)
        m2 <- (tet[2]^2 - (x - tet[1])^2)
        m3 <- x^3-tet[1]*(tet[1]^2+3*tet[2]^2)
        f <- cbind(m1,m2,m3)
        return(f)
        }


###################################################
### chunk number 3: 
###################################################
#line 198 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
Dg <- function(tet,x)
        {
        G <- matrix(c( 1,
                              2*(-tet[1]+mean(x)),
                              -3*tet[1]^2-3*tet[2]^2,0,
                              2*tet[2],-6*tet[1]*tet[2]),
                           nrow=3,ncol=2)
        return(G)
        }


###################################################
### chunk number 4: 
###################################################
#line 210 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
set.seed(123)
n <- 200
x1 <- rnorm(n, mean = 4, sd = 2)


###################################################
### chunk number 5: 
###################################################
#line 216 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
print(res <- gmm(g1,x1,c(mu = 0, sig = 0), grad = Dg))


###################################################
### chunk number 6: 
###################################################
#line 220 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
summary(res)


###################################################
### chunk number 7: 
###################################################
#line 224 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
specTest(res)


###################################################
### chunk number 8: 
###################################################
#line 228 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
sim_ex <- function(n,iter)
    {
    tet1 <- matrix(0,iter,2)
    tet2 <- tet1 
    for(i in 1:iter)
      {
      x1 <- rnorm(n, mean = 4, sd = 2)
      tet1[i,1] <- mean(x1)
      tet1[i,2] <- sqrt(var(x1)*(n-1)/n)
      tet2[i,] <- gmm(g1,x1,c(0,0),grad=Dg)$coefficients
      }
    bias <- cbind(rowMeans(t(tet1)-c(4,2)),rowMeans(t(tet2)-c(4,2)))
    dimnames(bias)<-list(c("mu","sigma"),c("ML","GMM"))
    Var <- cbind(diag(var(tet1)),diag(var(tet2)))
    dimnames(Var)<-list(c("mu","sigma"),c("ML","GMM"))
    MSE <- cbind(rowMeans((t(tet1)-c(4,2))^2),rowMeans((t(tet2)-c(4,2))^2))
    dimnames(MSE)<-list(c("mu","sigma"),c("ML","GMM"))
    return(list(bias=bias,Variance=Var,MSE=MSE))
    }


###################################################
### chunk number 9: 
###################################################
#line 276 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
g2 <- function(theta,x)
	{
	tau <- seq(1,5,length.out=10)
	pm <- 1
	x <- matrix(c(x),ncol=1)
	x_comp <- x%*%matrix(tau,nrow=1)
	x_comp <- matrix(complex(ima=x_comp),ncol=length(tau))
	emp_car <- exp(x_comp)
	the_car <- charStable(theta,tau,pm)
	gt <- t(t(emp_car) - the_car)
	gt <- cbind(Im(gt),Re(gt))
	return(gt)
	}


###################################################
### chunk number 10: 
###################################################
#line 292 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
library(fBasics)
set.seed(345)
x2 <- rstable(500,1.5,.5,pm=1)
t0 <- c(alpha = 2, beta = 0, gamma = sd(x2)/sqrt(2), delta = 0)
print(res <- gmm(g2,x2,t0))


###################################################
### chunk number 11: 
###################################################
#line 300 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
summary(res)


###################################################
### chunk number 12: 
###################################################
#line 304 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res2 <- gmm(g2,x2,t0,optfct="nlminb",lower=c(0,-1,0,-Inf),upper=c(2,1,Inf,Inf))
summary(res2)


###################################################
### chunk number 13: 
###################################################
#line 309 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
data(Finance)
x3 <- Finance[1:500,"WMK"]
t0<-c(alpha = 2, beta = 0, gamma = sd(x3)/sqrt(2),delta = 0)
res3 <- gmm(g2,x3,t0,optfct="nlminb",lower=c(0,-1,0,-Inf),upper=c(2,1,Inf,Inf))
summary(res3)


###################################################
### chunk number 14: 
###################################################
#line 317 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
library(car)
linearHypothesis(res3,cbind(diag(2),c(0,0),c(0,0)),c(2,0))


###################################################
### chunk number 15: 
###################################################
#line 343 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
library(mvtnorm)
sig <- matrix(c(1,.5,.5,1),2,2)
n <- 400
e <- rmvnorm(n,sigma=sig)
x4 <- rnorm(n)
w <- exp(-x4^2) + e[,1]
y <- 0.1*w + e[,2]


###################################################
### chunk number 16: 
###################################################
#line 353 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
h <- cbind(x4, x4^2, x4^3)
g3 <- y~w


###################################################
### chunk number 17: 
###################################################
#line 374 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
summary(res <- gmm(g3,x=h))


###################################################
### chunk number 18: 
###################################################
#line 378 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res2 <- gmm(g3,x=h,type='iterative',crit=1e-8,itermax=200)
coef(res2)


###################################################
### chunk number 19: 
###################################################
#line 385 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res3 <- gmm(g3,x=h,res2$coef,type='cue')
coef(res3)


###################################################
### chunk number 20: 
###################################################
#line 390 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
confint(res3,level=.90)


###################################################
### chunk number 21: 
###################################################
#line 397 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
plot(w,y,main="LS vs GMM estimation")
lines(w,fitted(res),col=2)
lines(w,fitted(lm(y~w)),col=3,lty=2)
lines(w,.1*w,col=4,lty=3)
legend("topleft",c("Data","Fitted GMM","Fitted LS","True line"),pch=c(1,NA,NA,NA),col=1:3,lty=c(NA,1,2,3))


###################################################
### chunk number 22: 
###################################################
#line 418 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
t <- 400
set.seed(345)
x5 <- arima.sim(n=t,list(ar=c(1.4,-0.6),ma=c(0.6,-0.3)))
x5t<-cbind(x5)
for (i in 1:6) x5t<-cbind(x5t,lag(x5,-i))
x5t<-na.omit(x5t)
g4<-x5t[,1]~x5t[,2]+x5t[,3]
res<-gmm(g4,x5t[,4:7])
summary(res)


###################################################
### chunk number 23: 
###################################################
#line 432 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res2 <- gmm(g4,x=x5t[,4:7],kernel="Truncated")
coef(res2)
res3 <- gmm(g4,x=x5t[,4:7],kernel="Bartlett")
coef(res3)
res4 <- gmm(g4,x=x5t[,4:7],kernel="Parzen")
coef(res4)
res5<- gmm(g4,x=x5t[,4:7],kernel="Tukey-Hanning")
coef(res5)


###################################################
### chunk number 24: 
###################################################
#line 443 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
diag(vcov(res2))^.5
diag(vcov(res3))^.5
diag(vcov(res4))^.5
diag(vcov(res5))^.5


###################################################
### chunk number 25: 
###################################################
#line 455 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
plot(res,which=2)


###################################################
### chunk number 26: 
###################################################
#line 461 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
plot(res,which=3)


###################################################
### chunk number 27: 
###################################################
#line 474 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
data(Finance)
r <- Finance[1:500,1:5]
rm <- Finance[1:500,"rm"]
rf <- Finance[1:500,"rf"]
z <- as.matrix(r-rf)
zm <- as.matrix(rm-rf)
res <- gmm(z~zm,x=zm)
coef(res)
R <- cbind(diag(5),matrix(0,5,5))
c <- rep(0,5)
linearHypothesis(res,R,c,test = "Chisq")


###################################################
### chunk number 28:  eval=FALSE
###################################################
## #line 488 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## test <- paste(names(coef(res)[1:5])," = 0",sep="")
## linearHypothesis(res,test)


###################################################
### chunk number 29: 
###################################################
#line 493 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res2<-gmm(z~zm-1,cbind(1,zm))
specTest(res2)


###################################################
### chunk number 30: 
###################################################
#line 506 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
g5 <- function(tet, x) {
     gmat <- (tet[1] + tet[2] * (1 + c(x[, 1]))) * (1 + x[, 2:6]) -  1
     return(gmat)
 }
res_sdf <- gmm(g5, x = as.matrix(cbind(rm, r)), c(0, 0))
specTest(res_sdf)


###################################################
### chunk number 31: 
###################################################
#line 541 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
g6 <- function(theta, x) {
     t <- length(x)
     et1 <- diff(x) - theta[1] - theta[2] * x[-t]
     ht <- et1^2 - theta[3] * x[-t]^(2 * theta[4])
     g <- cbind(et1, et1 * x[-t], ht, ht * x[-t])
     return(g)
 }


###################################################
### chunk number 32: 
###################################################
#line 551 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
rf <- Finance[,"rf"]
rf <- ((1 + rf/100)^(365) - 1) * 100
dr <- diff(rf)
res_0 <- lm(dr ~ rf[-length(rf)])
tet0 <- c(res_0$coef, var(residuals(res_0)), 0)
names(tet0) <- c("alpha", "beta", "sigma^2", "gamma")
res_rf <- gmm(g6, rf, tet0, control = list(maxit = 1000, reltol = 1e-10))
coef(res_rf)


###################################################
### chunk number 33:  eval=FALSE
###################################################
## #line 573 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## y <- rbind(y1-mean(y1),y2-mean(y2),y3-mean(y3))
## x <- rbind(x1-mean(x1),x2-mean(x2),x3-mean(x3))
## res <- gmm(y~x,h)


###################################################
### chunk number 34:  eval=FALSE
###################################################
## #line 583 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## y <- rbind(y1,y2,y3)
## x <- rbind(x1,x2,x3)
## res <- gmm(y~x,h)


###################################################
### chunk number 35:  eval=FALSE
###################################################
## #line 597 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## gt <- g(t0, x)
## V <- kernHAC(lm(gt~1),sandwich = FALSE)
## W <- solve(V)


###################################################
### chunk number 36: 
###################################################
#line 615 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
print(res<-gmm(g4,x5t[,4:7],wmatrix="ident"))
diag(vcovHAC(res))^.5


###################################################
### chunk number 37: 
###################################################
#line 620 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
diag(vcov(res))^.5


###################################################
### chunk number 38: 
###################################################
#line 624 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
print(res<-gmm(g4,x5t[,4:7], weightsMatrix = diag(5)))


###################################################
### chunk number 39: 
###################################################
#line 707 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
tet0 <- c(mu = mean(x1), sig = sd(x1))
res_el <- gel(g1,x1,tet0)
summary(res_el)


###################################################
### chunk number 40: 
###################################################
#line 715 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res_et <- gel(g1,x1,tet0,type="ET")
coef(res_et)


###################################################
### chunk number 41: 
###################################################
#line 719 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res_cue <- gel(g1,x1,tet0,type="CUE")
coef(res_cue)


###################################################
### chunk number 42: 
###################################################
#line 724 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
res <- gel(g1,x1,tet0,type="ETEL")
coef(res)


###################################################
### chunk number 43: 
###################################################
#line 749 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
tet0 <- gmm(g4,x=x5t[,4:7],wmatrix="ident")$coef
res <- gel(g4,x=x5t[,4:7],tet0,smooth=TRUE,kernel="Truncated")
summary(res)


###################################################
### chunk number 44: 
###################################################
#line 755 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
specTest(res)


###################################################
### chunk number 45: 
###################################################
#line 760 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
plot(res,which=4)


###################################################
### chunk number 46:  eval=FALSE
###################################################
## #line 765 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## ui=cbind(0,-1,-1)
## ci <- -1


###################################################
### chunk number 47:  eval=FALSE
###################################################
## #line 770 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## res <- gel(g4,x=dat5[,4:7],tet0,smooth=TRUE,kernel="Truncated",constraint=TRUE, ui=ui,ci=ci)


###################################################
### chunk number 48:  eval=FALSE
###################################################
## #line 776 "d:/Rcompile/CRANpkg/local/2.12/gmm/inst/doc/gmm_with_R.rnw"
## res <- gel(g4,x=dat5[,4:7],tet0,smooth=TRUE,kernel="Truncated",optlam="numeric")


